"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _select = _interopRequireDefault(require("../select"));

var _component = _interopRequireDefault(require("./component"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* globals describe, it, expect */
describe('The <Select /> component', function () {
  (0, _component.default)(_select.default);
  it('renders optgroups', function () {
    var options = [{
      label: 'A-1',
      value: 'a1'
    }, {
      label: 'B-1',
      value: 'b1',
      group: 'B-group'
    }, {
      label: 'B-2',
      value: 'b2',
      group: 'B-group'
    }, {
      label: 'C-1',
      value: 'c1'
    }, {
      label: 'B-3',
      value: 'b3',
      group: 'B-group'
    }, {
      label: 'D-1',
      value: 'd1',
      group: 'D-group'
    }, {
      label: 'E-1',
      value: 'e1'
    }];
    var wrapper = (0, _enzyme.mount)(_react.default.createElement(_select.default, {
      name: "myTestInput",
      label: "My Label",
      value: "b1",
      options: options
    })); // There should be 2 <optgroup>s

    expect(wrapper.find('optgroup').length).toBe(2); // There should be 7 <option>s

    expect(wrapper.find('option').length).toBe(7);
  });
});