"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.componentDefaultProps = exports.componentPropTypes = exports.styleClassNames = exports.styleClassName = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// JedWatson/classnames
// --------------------
//
// This is a PropType definition that is suitable for converting to a HTML 'class' attribute value.
// See: https://github.com/JedWatson/classnames
var styleClassName = _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array, _propTypes.default.object]);

exports.styleClassName = styleClassName;
var styleClassNames = {
  rowClassName: styleClassName,
  labelClassName: styleClassName,
  elementWrapperClassName: styleClassName
};
exports.styleClassNames = styleClassNames;

var componentPropTypes = _objectSpread({}, styleClassNames, {
  onChange: _propTypes.default.func,
  onSetValue: _propTypes.default.func,
  isPristine: _propTypes.default.func.isRequired,
  errorMessages: _propTypes.default.arrayOf(_propTypes.default.node),
  help: _propTypes.default.string,
  label: _propTypes.default.node,
  layout: _propTypes.default.oneOf(['horizontal', 'vertical', 'elementOnly']),
  showErrors: _propTypes.default.bool
});

exports.componentPropTypes = componentPropTypes;
var componentDefaultProps = {
  onChange: function onChange() {},
  onSetValue: function onSetValue() {},
  errorMessages: [],
  help: null,
  label: null,
  layout: 'horizontal',
  showErrors: true
};
exports.componentDefaultProps = componentDefaultProps;