"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Wraps an input to implement a Bootstrap [Input Group](http://getbootstrap.com/components/#input-groups)
 */
var InputGroup = function InputGroup(props) {
  var renderAddon = function renderAddon(addon) {
    if (!addon) {
      return null;
    }

    return _react.default.createElement("span", {
      className: "input-group-addon"
    }, addon);
  };

  var renderButton = function renderButton(button) {
    if (!button) {
      return null;
    }

    return _react.default.createElement("span", {
      className: "input-group-btn"
    }, button);
  };

  var addonBefore = props.addonBefore,
      addonAfter = props.addonAfter,
      buttonBefore = props.buttonBefore,
      buttonAfter = props.buttonAfter,
      children = props.children;
  return _react.default.createElement("div", {
    className: "input-group"
  }, renderAddon(addonBefore), renderButton(buttonBefore), children, renderAddon(addonAfter), renderButton(buttonAfter));
};

var propTypes = {
  children: _propTypes.default.node.isRequired,
  addonAfter: _propTypes.default.node,
  addonBefore: _propTypes.default.node,
  buttonAfter: _propTypes.default.node,
  buttonBefore: _propTypes.default.node
};
exports.propTypes = propTypes;
InputGroup.propTypes = propTypes;
InputGroup.defaultProps = {
  addonAfter: null,
  addonBefore: null,
  buttonAfter: null,
  buttonBefore: null
};
var _default = InputGroup;
exports.default = _default;