"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _debounce = _interopRequireDefault(require("../debounce"));

var _componentCommon = require("./component-common");

var _errorMessages = _interopRequireDefault(require("./error-messages"));

var _help = _interopRequireDefault(require("./help"));

var _icon = _interopRequireDefault(require("./icon"));

var _input = _interopRequireWildcard(require("./controls/input"));

var _inputGroup = _interopRequireWildcard(require("./input-group"));

var _row = _interopRequireDefault(require("./row"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Input =
/*#__PURE__*/
function (_Component) {
  _inherits(Input, _Component);

  function Input(props) {
    var _this;

    _classCallCheck(this, Input);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Input).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "componentWillReceiveProps", function (nextProps) {
      var stateValue = _this.state.value;
      var onSetValue = _this.props.onSetValue;
      var isValueChanging = nextProps.value !== stateValue;

      if (isValueChanging) {
        _this.setState({
          value: nextProps.value
        });

        onSetValue(nextProps.value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (event) {
      var value = event.currentTarget.value;
      var _this$props = _this.props,
          updateOnChange = _this$props.updateOnChange,
          onChange = _this$props.onChange,
          name = _this$props.name;

      _this.setState({
        value: value
      });

      if (updateOnChange) {
        _this.changeDebounced(value);
      }

      onChange(name, value);
    });

    _defineProperty(_assertThisInitialized(_this), "handleBlur", function (event) {
      var value = event.currentTarget.value;
      var _this$props2 = _this.props,
          updateOnBlur = _this$props2.updateOnBlur,
          isPristine = _this$props2.isPristine,
          onBlur = _this$props2.onBlur,
          name = _this$props2.name,
          propValue = _this$props2.value;

      _this.setState({
        value: value
      });

      if (updateOnBlur) {
        _this.changeDebounced.cancel();

        if (isPristine()) {
          // should update as we have just left a pristine input
          _this.blurDebounced(value);
        } else if (propValue !== value) {
          // should update because the value has changed
          _this.blurDebounced(value);
        }
      }

      onBlur(name, value);
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyDown", function (event) {
      var onKeyDown = _this.props.onKeyDown;

      if (event.key === 'Enter') {
        _this.changeDebounced.flush();
      }

      onKeyDown(event);
    });

    _defineProperty(_assertThisInitialized(_this), "initElementRef", function (control) {
      _this.element = control ? control.element : null;
    });

    _this.state = {
      value: props.value
    };
    _this.changeDebounced = (0, _debounce.default)(props.onSetValue, props.changeDebounceInterval);
    _this.blurDebounced = (0, _debounce.default)(props.onSetValue, props.blurDebounceInterval);
    return _this;
  }

  _createClass(Input, [{
    key: "render",
    value: function render() {
      var inputProps = Object.assign({}, this.props);
      Object.keys(_componentCommon.componentPropTypes).forEach(function (key) {
        delete inputProps[key];
      });
      delete inputProps.addonAfter;
      delete inputProps.addonBefore;
      delete inputProps.buttonAfter;
      delete inputProps.buttonBefore;
      delete inputProps.blurDebounceInterval;
      delete inputProps.changeDebounceInterval;
      delete inputProps.updateOnBlur;
      delete inputProps.updateOnChange;
      delete inputProps.value;
      delete inputProps.onBlur;
      var value = this.state.value;
      var _this$props3 = this.props,
          type = _this$props3.type,
          addonBefore = _this$props3.addonBefore,
          addonAfter = _this$props3.addonAfter,
          buttonBefore = _this$props3.buttonBefore,
          buttonAfter = _this$props3.buttonAfter,
          layout = _this$props3.layout,
          id = _this$props3.id,
          showErrors = _this$props3.showErrors,
          help = _this$props3.help,
          errorMessages = _this$props3.errorMessages;

      var control = _react.default.createElement(_input.default, _extends({}, inputProps, {
        value: value,
        onChange: this.handleChange,
        onBlur: this.handleBlur,
        onKeyDown: this.handleKeyDown,
        ref: this.initElementRef
      }));

      if (type === 'hidden') {
        return control;
      }

      if (addonBefore || addonAfter || buttonBefore || buttonAfter) {
        control = _react.default.createElement(_inputGroup.default, this.props, control);
      }

      if (layout === 'elementOnly') {
        return control;
      }

      return _react.default.createElement(_row.default, _extends({}, this.props, {
        htmlFor: id
      }), control, showErrors ? _react.default.createElement(_icon.default, {
        symbol: "remove",
        className: "form-control-feedback"
      }) : null, help ? _react.default.createElement(_help.default, {
        help: help
      }) : null, showErrors ? _react.default.createElement(_errorMessages.default, {
        messages: errorMessages
      }) : null);
    }
  }]);

  return Input;
}(_react.Component);

delete _inputGroup.propTypes.children;
Input.propTypes = _objectSpread({}, _input.propTypes, _inputGroup.propTypes, _componentCommon.componentPropTypes, {
  blurDebounceInterval: _propTypes.default.number,
  changeDebounceInterval: _propTypes.default.number,
  type: _propTypes.default.oneOf(['color', 'date', 'datetime', 'datetime-local', 'email', 'hidden', 'month', 'number', 'password', 'range', 'search', 'tel', 'text', 'time', 'url', 'week']),
  updateOnBlur: _propTypes.default.bool,
  updateOnChange: _propTypes.default.bool,
  value: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onKeyDown: _propTypes.default.func
});
Input.defaultProps = _objectSpread({}, _componentCommon.componentDefaultProps, _inputGroup.default.defaultProps, {
  type: 'text',
  value: '',
  updateOnBlur: true,
  updateOnChange: true,
  blurDebounceInterval: 0,
  changeDebounceInterval: 500,
  onBlur: function onBlur() {},
  onKeyDown: function onKeyDown() {}
});
var _default = Input;
exports.default = _default;