"use strict";

var _react = _interopRequireDefault(require("react"));

var _formsyReact = _interopRequireDefault(require("formsy-react"));

var _enzyme = require("enzyme");

var _component = _interopRequireDefault(require("../component"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

describe('The component HOC', function () {
  describe('css classes', function () {
    /*
        elementWrapperClassName: styleClassName,
        labelClassName: styleClassName,
        rowClassName: styleClassName,
        */
  });
  describe('props passed to the HOC', function () {
    var TestComponent = function TestComponent(props) {
      var InnerComponent = function InnerComponent() {
        return _react.default.createElement("div", null);
      };

      return _react.default.createElement(InnerComponent, props);
    };

    var FRC = (0, _component.default)(TestComponent);
    var wrapper = (0, _enzyme.mount)(_react.default.createElement(_formsyReact.default, null, _react.default.createElement(FRC, {
      name: "testComponent"
    })));
    var componentProps = wrapper.find(TestComponent).props();
    describe('`name`', function () {
      it('is required', function () {});
      it('should be a string', function () {});
      it('is passed through to the composed component', function () {});
    });
    describe('`disabled`', function () {
      it('is a boolean', function () {});
      it('is passed through to the composed component', function () {
        expect(_typeof(componentProps.disabled)).toBe('boolean');
      });
    });
    describe('`help`', function () {
      it('should be a string', function () {});
      it('is passed through to the composed component', function () {});
    });
    describe('`label`', function () {
      it('should be a string', function () {});
      it('is passed through to the composed component', function () {});
    });
    describe('`id`', function () {
      it('should be a string', function () {});
      it('is generated for the composed component when not supplied', function () {
        expect(_typeof(componentProps.id)).toBe('string');
        expect(componentProps.id.startsWith('frc-')).toBe(true);
      });
      it('is passed through to the composed component', function () {});
    });
    describe('`layout`', function () {
      it('defaults to `horizontal` if not supplied', function () {});
      it('is merged with a master value set in a parent context', function () {});
      it('is passed through to the composed component', function () {});
    });
    describe('`validatePristine`', function () {
      it('determines whether to show errors on pristine (untouched) values', function () {});
      it('is merged with a master value set in a parent context', function () {});
      it('is not passed through to the composed component', function () {});
    });
    describe('`validateOnSubmit`', function () {
      it('determines whether to hide errors until an attempt to submit the form is made', function () {});
      it('is merged with a master value set in a parent context', function () {});
      it('is not passed through to the composed component', function () {});
    });
    describe('other props', function () {
      it('are passed through to the composed component', function () {});
    });
  });
  describe('props set on the composed component', function () {
    // "Describle (v): To create a meaningless description."
    describe('`errorMessages`', function () {
      it('is an array', function () {});
      it('is the result of formsy `getErrorMessages`', function () {}); // errorMessages: this.props.getErrorMessages(),
    });
    describe('`id`', function () {
      it('is a string', function () {}); // id: this.getId(),
    });
    describe('`layout`', function () {
      it('is a string', function () {}); // layout: this.mergeLayoutContext(),
    });
    describe('`required`', function () {
      it('is a boolean', function () {});
      it('is the result of formsy `isRequired`', function () {}); // required: this.props.isRequired(),
    });
    describe('`showErrors`', function () {
      it('is a boolean', function () {}); // showErrors: this.shouldShowErrors(),
    });
    describe('css class name properties', function () {
      /*
            elementWrapperClassName: this.combineContextWithProp('elementWrapperClassName'),
            labelClassName:          this.combineContextWithProp('labelClassName'),
            rowClassName:            this.combineContextWithProp('rowClassName'),
            */
    });
    describe('`value`', function () {
      it('`value` is the result of formsy getValue()', function () {});
    });
    describe('`disabled`', function () {
      it('is a boolean', function () {}); // this.props.isFormDisabled() || this.props.disabled,

      it('is overridden by formsy `isFormDisabled` (if true)', function () {});
    });
    describe('`onSetValue`', function () {
      it('is a function', function () {});
      it('is just formsy setValue, with name changed to fit with project naming convention', function () {});
    });
  });
});